/* Soundscrape
 * Copyright (C) 2003,2004 Andy Wingo <wingo at pobox dot com>
 *
 * ss-spawn-adder.h: A helper element for Spawn
 *
 * This program is free software; you can redistribute it and/or    
 * modify it under the terms of the GNU General Public License as   
 * published by the Free Software Foundation; either version 2 of   
 * the License, or (at your option) any later version.              
 *                                                                  
 * This program is distributed in the hope that it will be useful,  
 * but WITHOUT ANY WARRANTY; without even the implied warranty of   
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    
 * GNU General Public License for more details.                     
 *                                                                  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, contact:
 *
 * Free Software Foundation           Voice:  +1-617-542-5942
 * 59 Temple Place - Suite 330        Fax:    +1-617-542-2652
 * Boston, MA  02111-1307,  USA       gnu@gnu.org
 *
 * Some code based on gstadder.c from gst-plugins:
 * Copyright (C) 1999,2000 Erik Walthinsen <omega@cse.ogi.edu>
 *               2000 Wim Taymans <wim.taymans@chello.be>
 *               2001 Thomas <thomas@apestaart.org>
 */

#ifndef __SS_SPAWN_ADDER_H__
#define __SS_SPAWN_ADDER_H__

#include "ss.h"

G_BEGIN_DECLS;


#define SS_TYPE_SPAWN_ADDER \
  (ss_spawn_adder_get_type())
#define SS_SPAWN_ADDER(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj),SS_TYPE_SPAWN_ADDER,SSSpawnAdder))
#define SS_SPAWN_ADDER_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass),SS_TYPE_SPAWN_ADDER,SSSpawnAdderClass))
#define SS_IS_SPAWN_ADDER(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj),SS_TYPE_SPAWN_ADDER))
#define SS_IS_SPAWN_ADDER_CLASS(obj) \
  (G_TYPE_CHECK_CLASS_TYPE((klass),SS_TYPE_SPAWN_ADDER))


typedef struct _SSSpawnAdder             SSSpawnAdder;
typedef struct _SSSpawnAdderClass        SSSpawnAdderClass;


struct _SSSpawnAdder {
    SSElement	element;

    GstPad	*srcpad;
    GList	*sinkpads;

    GClosure	*closure;
    gfloat	time;
    gboolean	buffer_sync;
};

struct _SSSpawnAdderClass {
    SSElementClass parent_class;
};


GType    ss_spawn_adder_get_type (void);
gboolean init_ss_spawn_adder (GstPlugin *plugin);


G_END_DECLS;

#endif /* __SS_SPAWN_ADDER_H__ */
